"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WidgetProvider = exports.WidgetContext = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require("react-redux");

var _utils = require("../utils");

var _widgetsActions = require("../actions/widgetsActions");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WidgetContext = exports.WidgetContext = _react2.default.createContext();

var WidgetProvider = exports.WidgetProvider = function (_React$Component) {
  _inherits(WidgetProvider, _React$Component);

  function WidgetProvider(props) {
    _classCallCheck(this, WidgetProvider);

    var _this = _possibleConstructorReturn(this, (WidgetProvider.__proto__ || Object.getPrototypeOf(WidgetProvider)).call(this, props));

    _this.getWidgets = _this.getWidgets.bind(_this);
    _this.fetchWidgets = _this.fetchWidgets.bind(_this);
    _this.value = { getWidgets: _this.getWidgets, fetchWidgets: _this.fetchWidgets };
    return _this;
  }

  /* Sample
   reqObj = {
     locations: 'desk.ticket.detail.rightpanel, desk.ticket.detail.lefttab',
     from : '0',
     limit: '10',
     sortBy: 'position',
     departmentId:'1234567890'
   } 
  */

  //TODO: add the intelisense to  handle from and limit


  _createClass(WidgetProvider, [{
    key: "fetchWidgets",
    value: function fetchWidgets(reqObj) {
      return this.props.apiCallHandler(reqObj);
    }
  }, {
    key: "getWidgets",
    value: function getWidgets(location, uID) {
      var widgetState = this.props.widgetState;

      return (0, _utils.constructWidgetData)(widgetState, location, uID);
    }
  }, {
    key: "renderWidgets",
    value: function renderWidgets(location, uID) {
      var _props = this.props,
          renderWidgetsAction = _props.renderWidgetsAction,
          widgetState = _props.widgetState;

      renderWidgetsAction((0, _utils.constructWidgetData)(widgetState, location, uID));
    }
  }, {
    key: "getWidgetInfo",
    value: function getWidgetInfo(widgetId) {
      var widgetState = this.props.widgetState;

      return widgetState.widgets[widgetId];
    }
  }, {
    key: "render",
    value: function render() {
      var children = this.props.children;

      return _react2.default.createElement(
        WidgetContext.Provider,
        { value: this.value },
        children
      );
    }
  }]);

  return WidgetProvider;
}(_react2.default.Component);

var mapStateToProps = function mapStateToProps(state, props) {
  return {
    widgetState: state[props.stateName]
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch, props) {
  return {
    apiCallHandler: function apiCallHandler(reqObj) {
      return dispatch(props.apiCallHandler(reqObj));
    },
    renderWidgetsAction: function renderWidgetsAction(widgets) {
      dispatch((0, _widgetsActions.renderWidgetsAction)(widgets));
    }
  };
};

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(WidgetProvider);